<?php

namespace MotaRaido\Core;

use \MotaRaido\Core\ErrorMessage;

if (!defined('MOTAFW')) 
{
    echo 'This file can only be called via the main index.php file, and not directly';
    exit();
}
class Route {

    private static $httpAction;

    public static function setHttpAction($action) {
        self::$httpAction = $action;
    }

	public static function get_uri() {
        if (isset($_SERVER['REQUEST_URI'])) {
            $uri = parse_url($_SERVER['REQUEST_URI'], PHP_URL_PATH);
        } else {
            return "";
        }
        return '/' . ltrim($uri, '/');
    }
    
	public static function add($pattern_uri, $action = null, $middleware = null) {
        self::setHttpAction(function($action) {
            echo $action['code'] . ' - ' . $action['message'];
        });

        $request_uri = self::get_uri();

        preg_match_all('/#([0-9a-zA-Z_]+)/', $pattern_uri, $names, PREG_PATTERN_ORDER);
        $names = $names[0];

		$pattern_uri_regex  = preg_replace_callback('/#[[0-9a-zA-Z_]+/', array(__CLASS__, 'uri_regex'), $pattern_uri);
        $pattern_uri_regex .= '/?';

        $params = array();
        
		if (preg_match('@^' . $pattern_uri_regex . '$@', $request_uri, $values)) {
            array_shift($values);

			foreach($names as $index => $value) {
				$params[substr($value, 1)] = urldecode($values[$index]);
            }
            
			if (is_callable($action)) {
                if(is_callable($middleware)) {
                    if(call_user_func($middleware)) {
                        call_user_func_array($action, array_values($params));
                    } else {
                        call_user_func_array(self::$httpAction, [ErrorMessage::get('401')]);
                    }
                } else {
                    call_user_func_array($action, array_values($params));
                }
			}
		}

		return $params;
    }
    
	public static function uri_regex($matches) {
		return '([a-zA-Z0-9_\+\-%]+)';
	}
}